#define MAIN

#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <string.h>

#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>  
  
#include "ocompare.h"

#define BLOCKSIZE 1024

char filename1[80];
char filename2[80];
uint8_t buffer1[BLOCKSIZE];
uint8_t buffer2[BLOCKSIZE];


uint16_t vergleich(uint16_t laenge)
{ uint16_t i;
  uint16_t errcounter;

  errcounter=0;

  for(i=0; i<laenge; i++)
     {
      if (buffer1[i] != buffer2[i])
	{
	  //	  printf(" %03xh:%02xh,%02xh ",i,buffer1[i],buffer2[i]);
	  errcounter++;
	}
    }

  if(errcounter !=0) printf ("Errors: %3i",errcounter);

  if(errcounter !=0) printf("\n"); else printf("\r");

  return(errcounter);
}
 
int main( int Anzahl, char **ParamString )
{
  FILE *File1, *File2;
  size_t s1;
  size_t s2;
  uint32_t PaketCounter;
  uint16_t ErrorCounter=0;;
  uint16_t Err=0;
  uint16_t ErrBlocks=0;

  if (Anzahl!=3) 
    {
      printf("ocompare file1 file2\n");
      exit(-1);
    }
  else
    {		
	          strcpy(filename1,ParamString[1]);
	          strcpy(filename2,ParamString[2]);

     };      
  printf("\nVergleich  [%s] und [%s]\n",filename1,filename2);
   
  File1=fopen(filename1,"rb");  
  if (File1<0) 
    {
      printf("\nFinde %s nicht!\n",filename1);
      exit((int)-1);
    }

  File2=fopen(filename2,"rb");
  if (File2<0) 
    {
      fclose(File1);
      printf("\nFinde %s nicht!\n",filename2);
      exit((int)-1);
    }
  
  PaketCounter=0;
  do
    {
      s1 = fread(buffer1,1,BLOCKSIZE,File1);
      s2 = fread(buffer2,1,BLOCKSIZE,File2);
      //printf("%i  %i\n",s1, s2);

      if ((s1 != BLOCKSIZE) || (s2 != BLOCKSIZE))
	{
	  printf("\r       "); //Letzte Fileposition vom Screen entfernen
	  fclose(File1);  fclose(File2);
	  printf("\n %i Fehler in %i Blöcken von %iByte\n",ErrorCounter,
                  ErrBlocks,BLOCKSIZE);
	  printf("Fehlerrate: %i von %i\n",ErrBlocks,PaketCounter);
	  exit(1);
	}

      printf("%06x:",PaketCounter);
      Err = vergleich(BLOCKSIZE);
      PaketCounter++;

      ErrorCounter += Err;

      if(Err>0) ErrBlocks++;

    } while( (s1==BLOCKSIZE) && (s2==BLOCKSIZE)   );



  fclose(File1);  fclose(File2);


  printf("\nFertig! %i Fehler in %i Blöcken von 512Byte\n",ErrorCounter,ErrBlocks);
   
}
